=== debian/changelog ===
bowtie2 (2.5.0-3) unstable; urgency=medium

  * Merge all autopkgtest scripts into run-unit-test as usual in Debian Med
    packages
  * Prevent autopkgtest on s390x since the package is no built here
  * Standards-Version: 4.6.2 (routine-update)

 -- Andreas Tille <tille@debian.org>  Tue, 17 Jan 2023 16:15:35 +0100

bowtie2 (2.5.0-2) unstable; urgency=medium

  * Package does not build on s390x any more

 -- Andreas Tille <tille@debian.org>  Mon, 12 Dec 2022 15:02:31 +0100

bowtie2 (2.5.0-1) unstable; urgency=medium

  * Team upload.

  [ Andreas Tille ]
  * No salsa-ci for i386
  * Use proper download file name
  * New upstream version
  * Standards-Version: 4.6.1 (routine-update)
  * Use secure URI in Homepage field.
  * Set upstream metadata fields: Bug-Database.
  * Update patches

  [ Étienne Mollier ]
  * simde patch: adjust to introduction of AVX2 support.
  * d/control: add pandoc to build doc/manual.html.
  * d/rules: trigger refresh of the doc/manual.html.
  * d/s/lintian-overrides: override missing source on doc/manual.html.

 -- Étienne Mollier <emollier@debian.org>  Sat, 05 Nov 2022 20:25:56 +0100
