=== Makefile ===
--- 
+++ 
@@ -32,19 +32,25 @@
 
 CXXFLAGS += -std=c++11
 
-ARCH = $(shell uname -m)
-NGS_VER ?= 2.9.2
-VDB_VER ?= 2.9.2-1
+NGS_VER ?= 2.10.2
+VDB_VER ?= 2.10.2
 
 # Detect Cygwin or MinGW
-WINDOWS :=
-MINGW :=
-ifneq (,$(findstring MINGW,$(shell uname)))
+ifneq (,$(findstring mingw,$(shell $(CXX) --version)))
   WINDOWS := 1
   MINGW := 1
-  # POSIX memory-mapped files not currently supported on Windows
-endif
-
+endif
+
+ifeq (1, $(MINGW))
+  CXX = x86_64-w64-mingw32-g++-posix
+  CC  = x86_64-w64-mingw32-gcc-posix
+  AR  = x86_64-w64-mingw32-ar
+  RC  = x86_64-w64-mingw32-windres
+  LD  = x86_64-w64-mingw32-ld
+  STRIP = x86_64-w64-mingw32-strip
+endif
+
+# POSIX memory-mapped files not currently supported on Windows
 ifeq (1, $(WINDOWS))
   BOWTIE_MM :=
   BOWTIE_SHARED_MEM :=
@@ -62,7 +68,8 @@
 endif
 
 BITS := 32
-ifneq (,$(findstring $(shell uname -m), x86_64 amd64))
+ARCH ?= $(shell uname -m)
+ifneq (,$(findstring $(ARCH), x86_64 amd64))
   BITS := 64
   ifeq (1, $(SSE_AVX2))
 	SSE_FLAG := -mavx2 -faligned-new -DSSE_AVX2
@@ -71,7 +78,7 @@
   endif
 
   POPCNT_CAPABILITY ?= 1
-else ifneq (,$(findstring $(shell uname -m), aarch64 arm64 s390x ppc64 ppc64le))
+else ifneq (,$(findstring $(ARCH), aarch64 arm64 s390x powerpc64 powerpc64le ppc64 ppc64le))
   BITS := 64
   SSE_FLAG :=
   CXXFLAGS += -fopenmp-simd
@@ -432,12 +439,3 @@
 # bowtie2-dp targets
 #
 
-bowtie2-dp: bt2_dp.cpp $(HEADERS) $(SHARED_CPPS) $(DP_CPPS)
-	$(CXX) $(RELEASE_FLAGS) \
-		$(RELEASE_DEFS) $(CXXFLAGS) $(NOASSERT_FLAGS) \
-		$(DEFS) -DBOWTIE2 -DBOWTIE_DP_MAIN -Wall \
-		$(CPPFLAGS) \
-		-o $@ $< \
-		$(DP_CPPS) $(SHARED_CPPS) \
-		$(LDFLAGS) $(LDLIBS)
-
