=== debian/changelog ===
bowtie2 (2.5.2-1) unstable; urgency=medium

  * New upstream version
  * Add build support for loongarch64
    Closes: #1059510

 -- Andreas Tille <tille@debian.org>  Wed, 10 Jan 2024 20:37:29 +0100

bowtie2 (2.5.1-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * refresh patches.
  * d/patches: update my email address, add some Forwarded hints
  * tests: remove need to build debug versions.
  * d/tests: run built-in tests as well.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 12 Sep 2023 13:16:13 +0200
