=== debian/control ===
--- 
+++ 
@@ -10,9 +10,9 @@
                libtbb-dev,
                python3,
                liblocal-lib-perl,
-               libtest-deep-perl,
-               libclone-perl,
-               libfile-which-perl,
+               libtest-deep-perl <!nocheck>,
+               libclone-perl <!nocheck>,
+               libfile-which-perl <!nocheck>,
                zlib1g-dev,
                libsimde-dev
 Standards-Version: 4.6.2
@@ -22,7 +22,7 @@
 Rules-Requires-Root: no
 
 Package: bowtie2
-Architecture: any-amd64 arm64 mips64el ppc64el ia64 m68k ppc64 riscv64 sh4 sparc64
+Architecture: any-amd64 arm64 loong64 mips64el ppc64el ia64 m68k ppc64 riscv64 sh4 sparc64
 Depends: python3,
          ${misc:Depends},
          ${shlibs:Depends},
