## bowtie2 2.5.3

=== debian/changelog ===
bowtie2 (2.5.3-1) unstable; urgency=medium

  [ Michael R. Crusoe ]
  * Team upload.
  * d/control: simplify architecture specifications by using provisions
    from the architecture-properties package.

 -- Charles Plessy <plessy@debian.org>  Wed, 17 Apr 2024 08:56:57 +0900

bowtie2 (2.5.2-2) UNRELEASED; urgency=medium

  * Remove exclusion from architecture s390x from test since its not relevant
    for migration any more

 -- Andreas Tille <tille@debian.org>  Thu, 18 Jan 2024 11:26:40 +0100
