=== debian/control ===
--- 
+++ 
@@ -5,6 +5,8 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+               architecture-is-64-bit,
+               architecture-is-little-endian,
                help2man,
                pandoc <!nodoc>,
                libtbb-dev,
@@ -22,7 +24,7 @@
 Rules-Requires-Root: no
 
 Package: bowtie2
-Architecture: any-amd64 arm64 loong64 mips64el ppc64el ia64 m68k ppc64 riscv64 sh4 sparc64
+Architecture: any
 Depends: python3,
          ${misc:Depends},
          ${shlibs:Depends},
