=== Makefile ===
--- 
+++ 
@@ -30,10 +30,14 @@
 BOWTIE_MM := 1
 BOWTIE_SHARED_MEM :=
 
-CXXFLAGS += -std=c++11
-
-NGS_VER ?= 2.10.2
-VDB_VER ?= 2.10.2
+CXXFLAGS += -std=c++11 -Wall -Wno-unused-but-set-variable
+
+SRA_TOOLS_VER ?= 3.0.9
+VDB_VER ?= 3.0.9
+
+ifneq (,$(findstring $(shell uname),Linux))
+  LDLIBS += -lrt
+endif
 
 # Detect Cygwin or MinGW
 ifneq (,$(findstring mingw,$(shell $(CXX) --version)))
@@ -42,6 +46,7 @@
 endif
 
 ifeq (1, $(MINGW))
+  LDLIBS := $(subst -lrt,,$(LDLIBS))
   CXX = x86_64-w64-mingw32-g++-posix
   CC  = x86_64-w64-mingw32-gcc-posix
   AR  = x86_64-w64-mingw32-ar
@@ -86,11 +91,14 @@
   POPCNT_CAPABILITY ?= 0
 endif
 
-ifdef USE_SAIS
+ifeq (1, $(if $(or $(USE_SAIS),$(USE_SAIS_OPENMP)),1))
   CPPFLAGS += -Ithird_party/libsais/include
-  CXXFLAGS += -fopenmp -DUSE_SAIS
-  LDFLAGS += -Lthird_party/libsais/lib
-  LDLIBS += -lsais
+ifdef USE_SAIS_OPENMP
+  BUILD_CXXFLAGS += -fopenmp
+endif
+  BUILD_CXXFLAGS += -DUSE_SAIS
+  BUILD_LDFLAGS += -Lthird_party/libsais/lib
+  BUILD_LDLIBS += -lsais
 endif
 
 # msys will always be 32 bit so look at the cpu arch instead.
@@ -104,6 +112,7 @@
 endif
 
 ifdef STATIC_BUILD
+  WITH_ZSTD = 1
   LDFLAGS += -L$(CURDIR)/.tmp/lib
   CPPFLAGS += -I$(CURDIR)/.tmp/include
 endif
@@ -147,10 +156,9 @@
     ifndef ($(STATIC_BUILD))
       CPPFLAGS += -I$(CURDIR)/.tmp/include
     endif
-    LDLIBS += -lncbi-ngs-c++-static
-    LDLIBS += -lngs-c++-static
-    LDLIBS += -lncbi-vdb-static
-    LDLIBS += -ldl
+    ALIGN_LDLIBS += -lncbi-ngs-static
+    ALIGN_LDLIBS += -lncbi-vdb-static
+    ALIGN_LDLIBS += -ldl
     CXXFLAGS += -DUSE_SRA
   endif
 endif
@@ -322,12 +330,17 @@
 $(BOWTIE2_BIN_LIST_SAN): $(error "Compiler does not support...")
 endif
 
+bowtie2-build-%: CXXFLAGS += $(BUILD_CXXFLAGS)
+bowtie2-build-%: LDFLAGS += $(BUILD_LDFLAGS)
+bowtie2-build-%: LDLIBS += $(BUILD_LDLIBS)
+
+bowtie2-align-%: LDLIBS += $(ALIGN_LDLIBS)
 #
 # bowtie2-build targets
 #
 bowtie2-build-s-sanitized bowtie2-build-s: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
 	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
-		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall \
+		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS)  \
 		$(CPPFLAGS) \
 		-o $@ $< \
 		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
@@ -335,7 +348,7 @@
 
 bowtie2-build-l-sanitized bowtie2-build-l: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
 	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
-		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS)  \
 		$(CPPFLAGS) \
 		-o $@ $< \
 		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
@@ -343,7 +356,7 @@
 
 bowtie2-build-s-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
 	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(CXXFLAGS) \
-		$(DEFS) -DBOWTIE2 -Wall \
+		$(DEFS) -DBOWTIE2  \
 		$(CPPFLAGS) \
 		-o $@ $< \
 		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
@@ -351,7 +364,7 @@
 
 bowtie2-build-l-debug: bt2_build.cpp $(SHARED_CPPS) $(HEADERS)
 	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(CXXFLAGS) \
-		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX  \
 		$(CPPFLAGS) \
 		-o $@ $< \
 		$(SHARED_CPPS) $(BUILD_CPPS_MAIN) \
@@ -363,7 +376,7 @@
 
 bowtie2-align-s-sanitized bowtie2-align-s: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
 	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
-		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) -Wall \
+		$(DEFS) -DBOWTIE2 $(NOASSERT_FLAGS) \
 		$(CPPFLAGS) \
 		-o $@ $< \
 		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
@@ -371,7 +384,7 @@
 
 bowtie2-align-l-sanitized bowtie2-align-l: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
 	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(CXXFLAGS) \
-		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) -Wall \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS)  \
 		$(CPPFLAGS) \
 		-o $@ $< \
 		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
@@ -380,7 +393,7 @@
 bowtie2-align-s-debug: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
 	$(CXX) $(DEBUG_FLAGS) \
 		$(DEBUG_DEFS) $(CXXFLAGS) \
-		$(DEFS) -DBOWTIE2 -Wall \
+		$(DEFS) -DBOWTIE2  \
 		$(CPPFLAGS) \
 		-o $@ $< \
 		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
@@ -389,7 +402,7 @@
 bowtie2-align-l-debug: bt2_search.cpp $(SEARCH_CPPS) $(SHARED_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
 	$(CXX) $(DEBUG_FLAGS) \
 		$(DEBUG_DEFS) $(CXXFLAGS) \
-		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -Wall \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX  \
 		$(CPPFLAGS) \
 		-o $@ $< \
 		$(SHARED_CPPS) $(SEARCH_CPPS_MAIN) \
@@ -402,7 +415,7 @@
 bowtie2-inspect-s-sanitized bowtie2-inspect-s: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
 	$(CXX) $(RELEASE_FLAGS) \
 		$(RELEASE_DEFS) $(CXXFLAGS) \
-		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN  \
 		$(CPPFLAGS) \
 		-o $@ $< \
 		$(SHARED_CPPS) \
@@ -411,7 +424,7 @@
 bowtie2-inspect-l-sanitized bowtie2-inspect-l: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
 	$(CXX) $(RELEASE_FLAGS) \
 		$(RELEASE_DEFS) $(CXXFLAGS) \
-		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN  -DBOWTIE_64BIT_INDEX -Wall \
+		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN  -DBOWTIE_64BIT_INDEX  \
 		$(CPPFLAGS) \
 		-o $@ $< \
 		$(SHARED_CPPS) \
@@ -420,22 +433,6 @@
 bowtie2-inspect-s-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
 	$(CXX) $(DEBUG_FLAGS) \
 		$(DEBUG_DEFS) $(CXXFLAGS) \
-		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN -Wall \
-		$(CPPFLAGS) \
-		-o $@ $< \
-		$(SHARED_CPPS) \
-		$(LDFLAGS) $(LDLIBS)
-
-bowtie2-inspect-l-debug: bt2_inspect.cpp $(HEADERS) $(SHARED_CPPS)
-	$(CXX) $(DEBUG_FLAGS) \
-		$(DEBUG_DEFS) $(CXXFLAGS) \
-		$(DEFS) -DBOWTIE2 -DBOWTIE_64BIT_INDEX -DBOWTIE_INSPECT_MAIN -Wall \
-		$(CPPFLAGS) \
-		-o $@ $< \
-		$(SHARED_CPPS) \
-		$(LDFLAGS) $(LDLIBS)
-
-#
-# bowtie2-dp targets
-#
-
+		$(DEFS) -DBOWTIE2 -DBOWTIE_INSPECT_MAIN  \
+		$(CPPFLAGS) \
+		-o $@ $< \
