=== debian/changelog ===
bowtie2 (2.5.4-1) unstable; urgency=medium

  * Remove libmath-random-perl from Test-Depends and complete patch removing
    tests needing this module
    Closes: #1078087
  * New upstream version
  * Standards-Version: 4.7.0 (routine-update)

 -- Andreas Tille <tille@debian.org>  Wed, 07 Aug 2024 13:31:40 +0200
