=== debian/control ===
--- 
+++ 
@@ -17,7 +17,7 @@
                libfile-which-perl <!nocheck>,
                zlib1g-dev,
                libsimde-dev
-Standards-Version: 4.6.2
+Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/bowtie2
 Vcs-Git: https://salsa.debian.org/med-team/bowtie2.git
 Homepage: https://bowtie-bio.sourceforge.net/bowtie2
