=== debian/rules ===
--- 
+++ 
@@ -31,13 +31,6 @@
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	LD_PRELOAD= $(MAKE) EXTRA_FLAGS="-std=c++98 $(LDFLAGS)" $(EXTRA_OPTIONS) \
-	  bowtie2-build-s-debug \
-	  bowtie2-build-l-debug \
-	  bowtie2-align-s-debug \
-	  bowtie2-align-l-debug \
-	  bowtie2-inspect-s-debug \
-	  bowtie2-inspect-l-debug
 	LD_PRELOAD= make -j1 test
 endif
