=== debian/tests/control ===
Tests: run-unit-test
Depends: @, libclone-perl, libtest-deep-perl, libclone-perl, libfile-which-perl, libsys-info-perl
Restrictions: allow-stderr
